Merge branch 'devel-2.4'
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Use bash in order to be able to use pipefail
13 SHELL=/bin/bash
14
15 ACLOCAL_AMFLAGS = -I autotools
16 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
17 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
18 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
19 CHECK_MAN = $(top_srcdir)/autotools/check-man
20 CHECK_VERSION = $(top_srcdir)/autotools/check-version
21 CHECK_NEWS = $(top_srcdir)/autotools/check-news
22 REPLACE_VARS_SED = autotools/replace_vars.sed
23
24 clientdir = $(pkgpythondir)/client
25 hypervisordir = $(pkgpythondir)/hypervisor
26 httpdir = $(pkgpythondir)/http
27 masterddir = $(pkgpythondir)/masterd
28 confddir = $(pkgpythondir)/confd
29 rapidir = $(pkgpythondir)/rapi
30 serverdir = $(pkgpythondir)/server
31 watcherdir = $(pkgpythondir)/watcher
32 impexpddir = $(pkgpythondir)/impexpd
33 utilsdir = $(pkgpythondir)/utils
34 toolsdir = $(pkglibdir)/tools
35 docdir = $(datadir)/doc/$(PACKAGE)
36
37 # Delete output file if an error occurred while building it
38 .DELETE_ON_ERROR:
39
40 DIRS = \
41         autotools \
42         daemons \
43         devel \
44         doc \
45         doc/examples \
46         doc/examples/hooks \
47         doc/examples/gnt-debug \
48         lib \
49         lib/client \
50         lib/build \
51         lib/confd \
52         lib/http \
53         lib/hypervisor \
54         lib/impexpd \
55         lib/masterd \
56         lib/rapi \
57         lib/server \
58         lib/utils \
59         lib/watcher \
60         man \
61         qa \
62         test \
63         test/data \
64         tools
65
66 BUILDTIME_DIR_AUTOCREATE = \
67         scripts \
68         doc/api \
69         doc/coverage
70
71 BUILDTIME_DIRS = \
72         $(BUILDTIME_DIR_AUTOCREATE) \
73         doc/html
74
75 DIRCHECK_EXCLUDE = \
76         $(BUILDTIME_DIRS) \
77         ganeti-[0-9]*.[0-9]*.[0-9]* \
78         doc/html/_*
79
80 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
81
82 MAINTAINERCLEANFILES = \
83         $(docpng) \
84         $(maninput) \
85         doc/install-quick.rst \
86         doc/news.rst \
87         doc/upgrade.rst \
88         vcs-version
89
90 maintainer-clean-local:
91         rm -rf $(BUILDTIME_DIRS)
92
93 CLEANFILES = \
94         $(addsuffix /*.py[co],$(DIRS)) \
95         $(all_dirfiles) \
96         $(PYTHON_BOOTSTRAP) \
97         epydoc.conf \
98         autotools/replace_vars.sed \
99         daemons/daemon-util \
100         daemons/ensure-dirs \
101         daemons/ganeti-cleaner \
102         devel/upload \
103         doc/examples/bash_completion \
104         doc/examples/ganeti.initd \
105         doc/examples/ganeti-kvm-poweroff.initd \
106         doc/examples/ganeti.cron \
107         doc/examples/gnt-config-backup \
108         doc/examples/hooks/ipsec \
109         $(man_MANS) \
110         $(manhtml) \
111         tools/kvm-ifup \
112         stamp-srclinks \
113         $(nodist_pkgpython_PYTHON)
114
115 # BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
116 # it'll cause the target to rebuild every time.
117 BUILT_SOURCES = \
118         ganeti \
119         stamp-srclinks \
120         lib/_autoconf.py \
121         $(all_dirfiles) \
122         $(PYTHON_BOOTSTRAP)
123
124 nodist_pkgpython_PYTHON = \
125         lib/_autoconf.py
126
127 noinst_PYTHON = \
128         lib/build/__init__.py
129
130 pkgpython_PYTHON = \
131         lib/__init__.py \
132         lib/asyncnotifier.py \
133         lib/backend.py \
134         lib/bdev.py \
135         lib/bootstrap.py \
136         lib/cli.py \
137         lib/cmdlib.py \
138         lib/compat.py \
139         lib/config.py \
140         lib/constants.py \
141         lib/daemon.py \
142         lib/errors.py \
143         lib/ht.py \
144         lib/jqueue.py \
145         lib/jstore.py \
146         lib/locking.py \
147         lib/luxi.py \
148         lib/mcpu.py \
149         lib/netutils.py \
150         lib/objects.py \
151         lib/opcodes.py \
152         lib/qlang.py \
153         lib/query.py \
154         lib/rpc.py \
155         lib/runtime.py \
156         lib/serializer.py \
157         lib/ssconf.py \
158         lib/ssh.py \
159         lib/storage.py \
160         lib/uidpool.py \
161         lib/workerpool.py
162
163 client_PYTHON = \
164         lib/client/__init__.py \
165         lib/client/gnt_backup.py \
166         lib/client/gnt_cluster.py \
167         lib/client/gnt_debug.py \
168         lib/client/gnt_group.py \
169         lib/client/gnt_instance.py \
170         lib/client/gnt_job.py \
171         lib/client/gnt_node.py \
172         lib/client/gnt_os.py
173
174 hypervisor_PYTHON = \
175         lib/hypervisor/__init__.py \
176         lib/hypervisor/hv_base.py \
177         lib/hypervisor/hv_chroot.py \
178         lib/hypervisor/hv_fake.py \
179         lib/hypervisor/hv_kvm.py \
180         lib/hypervisor/hv_lxc.py \
181         lib/hypervisor/hv_xen.py
182
183 rapi_PYTHON = \
184         lib/rapi/__init__.py \
185         lib/rapi/baserlib.py \
186         lib/rapi/client.py \
187         lib/rapi/client_utils.py \
188         lib/rapi/connector.py \
189         lib/rapi/rlib2.py
190
191 http_PYTHON = \
192         lib/http/__init__.py \
193         lib/http/auth.py \
194         lib/http/client.py \
195         lib/http/server.py
196
197 confd_PYTHON = \
198         lib/confd/__init__.py \
199         lib/confd/client.py \
200         lib/confd/querylib.py \
201         lib/confd/server.py
202
203 masterd_PYTHON = \
204         lib/masterd/__init__.py \
205         lib/masterd/instance.py
206
207 impexpd_PYTHON = \
208         lib/impexpd/__init__.py
209
210 watcher_PYTHON = \
211         lib/watcher/__init__.py
212
213 server_PYTHON = \
214         lib/server/__init__.py \
215         lib/server/confd.py \
216         lib/server/masterd.py \
217         lib/server/noded.py \
218         lib/server/rapi.py
219
220 utils_PYTHON = \
221         lib/utils/__init__.py \
222         lib/utils/algo.py \
223         lib/utils/filelock.py \
224         lib/utils/hash.py \
225         lib/utils/io.py \
226         lib/utils/log.py \
227         lib/utils/mlock.py \
228         lib/utils/nodesetup.py \
229         lib/utils/process.py \
230         lib/utils/retry.py \
231         lib/utils/text.py \
232         lib/utils/wrapper.py \
233         lib/utils/x509.py
234
235 docrst = \
236         doc/admin.rst \
237         doc/design-2.0.rst \
238         doc/design-2.1.rst \
239         doc/design-2.2.rst \
240         doc/design-2.3.rst \
241         doc/design-2.4.rst \
242         doc/design-draft.rst \
243         doc/design-oob.rst \
244         doc/design-query2.rst \
245         doc/cluster-merge.rst \
246         doc/devnotes.rst \
247         doc/glossary.rst \
248         doc/hooks.rst \
249         doc/iallocator.rst \
250         doc/index.rst \
251         doc/install-quick.rst \
252         doc/install.rst \
253         doc/locking.rst \
254         doc/move-instance.rst \
255         doc/news.rst \
256         doc/rapi.rst \
257         doc/security.rst \
258         doc/upgrade.rst \
259         doc/walkthrough.rst
260
261 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
262
263 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
264         $(RUN_IN_TEMPDIR)
265         @test -n "$(SPHINX)" || \
266             { echo 'sphinx-build' not found during configure; exit 1; }
267         @mkdir_p@ $(dir $@)
268         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
269             -d . \
270             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
271             -D release="$(PACKAGE_VERSION)" \
272             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
273         rm -f doc/html/.buildinfo doc/html/objects.inv
274         touch $@
275
276 doc/html: doc/html/index.html
277
278 doc/install-quick.rst: INSTALL
279 doc/news.rst: NEWS
280 doc/upgrade.rst: UPGRADE
281
282 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
283         set -e; \
284         { echo '.. This file is automatically updated at build time from $<.'; \
285           echo '.. Do not edit.'; \
286           echo; \
287           cat $<; \
288         } > $@
289
290 docdot = \
291         doc/arch-2.0.dot \
292         doc/design-2.1-lock-acquire.dot \
293         doc/design-2.1-lock-release.dot
294
295 docpng = $(patsubst %.dot,%.png,$(docdot))
296
297 # Things to build but not to install (add it to EXTRA_DIST if it should be
298 # distributed)
299 noinst_DATA = \
300         devel/upload \
301         doc/html \
302         doc/examples/bash_completion \
303         doc/examples/ganeti.cron \
304         doc/examples/ganeti.initd \
305         doc/examples/ganeti-kvm-poweroff.initd \
306         doc/examples/gnt-config-backup \
307         doc/examples/hooks/ipsec \
308         $(manhtml)
309
310 gnt_scripts = \
311         scripts/gnt-backup \
312         scripts/gnt-cluster \
313         scripts/gnt-debug \
314         scripts/gnt-group \
315         scripts/gnt-instance \
316         scripts/gnt-job \
317         scripts/gnt-node \
318         scripts/gnt-os
319
320 PYTHON_BOOTSTRAP = \
321         daemons/ganeti-confd \
322         daemons/ganeti-masterd \
323         daemons/ganeti-noded \
324         daemons/ganeti-watcher \
325         daemons/ganeti-rapi \
326         scripts/gnt-backup \
327         scripts/gnt-cluster \
328         scripts/gnt-debug \
329         scripts/gnt-group \
330         scripts/gnt-instance \
331         scripts/gnt-job \
332         scripts/gnt-node \
333         scripts/gnt-os
334
335 qa_scripts = \
336         qa/ganeti-qa.py \
337         qa/qa_cluster.py \
338         qa/qa_config.py \
339         qa/qa_daemon.py \
340         qa/qa_env.py \
341         qa/qa_error.py \
342         qa/qa_instance.py \
343         qa/qa_node.py \
344         qa/qa_os.py \
345         qa/qa_rapi.py \
346         qa/qa_tags.py \
347         qa/qa_utils.py
348
349 dist_sbin_SCRIPTS = \
350         tools/ganeti-listrunner
351
352 nodist_sbin_SCRIPTS = \
353         $(PYTHON_BOOTSTRAP) \
354         daemons/ganeti-cleaner
355
356 dist_tools_SCRIPTS = \
357         tools/burnin \
358         tools/cfgshell \
359         tools/cfgupgrade \
360         tools/cfgupgrade12 \
361         tools/cluster-merge \
362         tools/lvmstrap \
363         tools/move-instance \
364         tools/setup-ssh \
365         tools/sanitize-config
366
367 pkglib_python_scripts = \
368         daemons/import-export \
369         tools/check-cert-expired
370
371 pkglib_SCRIPTS = \
372         daemons/daemon-util \
373         daemons/ensure-dirs \
374         tools/kvm-ifup \
375         $(pkglib_python_scripts)
376
377 EXTRA_DIST = \
378         NEWS \
379         UPGRADE \
380         epydoc.conf.in \
381         pylintrc \
382         autotools/build-bash-completion \
383         autotools/check-python-code \
384         autotools/check-man \
385         autotools/check-news \
386         autotools/check-tar \
387         autotools/check-version \
388         autotools/gen-coverage \
389         autotools/testrunner \
390         $(RUN_IN_TEMPDIR) \
391         daemons/daemon-util.in \
392         daemons/ensure-dirs.in \
393         daemons/ganeti-cleaner.in \
394         $(pkglib_python_scripts) \
395         devel/upload.in \
396         tools/kvm-ifup.in \
397         $(docdot) \
398         $(docpng) \
399         $(docrst) \
400         doc/conf.py \
401         doc/html \
402         doc/examples/ganeti.initd.in \
403         doc/examples/ganeti-kvm-poweroff.initd.in \
404         doc/examples/ganeti.cron.in \
405         doc/examples/gnt-config-backup.in \
406         doc/examples/ganeti.default \
407         doc/examples/ganeti.default-debug \
408         doc/examples/hooks/ethers \
409         doc/examples/hooks/ipsec.in \
410         doc/examples/gnt-debug/README \
411         doc/examples/gnt-debug/delay0.json \
412         doc/examples/gnt-debug/delay50.json \
413         test/testutils.py \
414         test/mocks.py \
415         $(dist_TESTS) \
416         $(TEST_FILES) \
417         man/footer.rst \
418         $(manrst) \
419         $(maninput) \
420         qa/qa-sample.json \
421         $(qa_scripts)
422
423 man_MANS = \
424         man/ganeti.7 \
425         man/ganeti-cleaner.8 \
426         man/ganeti-confd.8 \
427         man/ganeti-listrunner.8 \
428         man/ganeti-masterd.8 \
429         man/ganeti-noded.8 \
430         man/ganeti-os-interface.7 \
431         man/ganeti-rapi.8 \
432         man/ganeti-watcher.8 \
433         man/gnt-backup.8 \
434         man/gnt-cluster.8 \
435         man/gnt-debug.8 \
436         man/gnt-group.8 \
437         man/gnt-instance.8 \
438         man/gnt-job.8 \
439         man/gnt-node.8 \
440         man/gnt-os.8
441
442 manrst = $(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS)))
443 manhtml = $(patsubst %.rst,%.html,$(manrst))
444 maninput = \
445         $(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS))) \
446         $(patsubst %.html,%.html.in,$(manhtml)) \
447         man/footer.man man/footer.html
448
449 TEST_FILES = \
450         test/data/bdev-drbd-8.0.txt \
451         test/data/bdev-drbd-8.3.txt \
452         test/data/bdev-drbd-disk.txt \
453         test/data/bdev-drbd-net-ip4.txt \
454         test/data/bdev-drbd-net-ip6.txt \
455         test/data/cert1.pem \
456         test/data/proc_drbd8.txt \
457         test/data/proc_drbd80-emptyline.txt \
458         test/data/proc_drbd83.txt \
459         test/data/sys_drbd_usermode_helper.txt \
460         test/import-export_unittest-helper
461
462 python_tests = \
463         test/ganeti.asyncnotifier_unittest.py \
464         test/ganeti.backend_unittest.py \
465         test/ganeti.bdev_unittest.py \
466         test/ganeti.cli_unittest.py \
467         test/ganeti.client.gnt_instance_unittest.py \
468         test/ganeti.daemon_unittest.py \
469         test/ganeti.cmdlib_unittest.py \
470         test/ganeti.compat_unittest.py \
471         test/ganeti.confd.client_unittest.py \
472         test/ganeti.config_unittest.py \
473         test/ganeti.constants_unittest.py \
474         test/ganeti.errors_unittest.py \
475         test/ganeti.hooks_unittest.py \
476         test/ganeti.ht_unittest.py \
477         test/ganeti.http_unittest.py \
478         test/ganeti.hypervisor_unittest.py \
479         test/ganeti.hypervisor.hv_chroot_unittest.py \
480         test/ganeti.hypervisor.hv_fake_unittest.py \
481         test/ganeti.hypervisor.hv_kvm_unittest.py \
482         test/ganeti.hypervisor.hv_lxc_unittest.py \
483         test/ganeti.hypervisor.hv_xen_unittest.py \
484         test/ganeti.impexpd_unittest.py \
485         test/ganeti.jqueue_unittest.py \
486         test/ganeti.locking_unittest.py \
487         test/ganeti.luxi_unittest.py \
488         test/ganeti.masterd.instance_unittest.py \
489         test/ganeti.mcpu_unittest.py \
490         test/ganeti.netutils_unittest.py \
491         test/ganeti.objects_unittest.py \
492         test/ganeti.opcodes_unittest.py \
493         test/ganeti.qlang_unittest.py \
494         test/ganeti.query_unittest.py \
495         test/ganeti.rapi.baserlib_unittest.py \
496         test/ganeti.rapi.client_unittest.py \
497         test/ganeti.rapi.resources_unittest.py \
498         test/ganeti.rapi.rlib2_unittest.py \
499         test/ganeti.rpc_unittest.py \
500         test/ganeti.runtime_unittest.py \
501         test/ganeti.serializer_unittest.py \
502         test/ganeti.ssh_unittest.py \
503         test/ganeti.uidpool_unittest.py \
504         test/ganeti.utils.algo_unittest.py \
505         test/ganeti.utils.filelock_unittest.py \
506         test/ganeti.utils.hash_unittest.py \
507         test/ganeti.utils.io_unittest.py \
508         test/ganeti.utils.mlock_unittest.py \
509         test/ganeti.utils.nodesetup_unittest.py \
510         test/ganeti.utils.process_unittest.py \
511         test/ganeti.utils.retry_unittest.py \
512         test/ganeti.utils.text_unittest.py \
513         test/ganeti.utils.wrapper_unittest.py \
514         test/ganeti.utils.x509_unittest.py \
515         test/ganeti.utils_unittest.py \
516         test/ganeti.workerpool_unittest.py \
517         test/cfgupgrade_unittest.py \
518         test/docs_unittest.py \
519         test/tempfile_fork_unittest.py
520
521 dist_TESTS = \
522         test/check-cert-expired_unittest.bash \
523         test/daemon-util_unittest.bash \
524         test/ganeti-cleaner_unittest.bash \
525         test/import-export_unittest.bash \
526         $(python_tests)
527
528 nodist_TESTS =
529
530 TESTS = $(dist_TESTS) $(nodist_TESTS)
531
532 # Environment for all tests
533 PLAIN_TESTS_ENVIRONMENT = \
534         PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) $(RUN_IN_TEMPDIR)
535
536 # Environment for tests run by automake
537 TESTS_ENVIRONMENT = \
538         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
539
540 all_python_code = \
541         $(dist_sbin_SCRIPTS) \
542         $(dist_tools_SCRIPTS) \
543         $(pkglib_python_scripts) \
544         $(python_tests) \
545         $(pkgpython_PYTHON) \
546         $(client_PYTHON) \
547         $(hypervisor_PYTHON) \
548         $(rapi_PYTHON) \
549         $(server_PYTHON) \
550         $(http_PYTHON) \
551         $(confd_PYTHON) \
552         $(masterd_PYTHON) \
553         $(impexpd_PYTHON) \
554         $(utils_PYTHON) \
555         $(watcher_PYTHON) \
556         $(noinst_PYTHON) \
557         $(qa_scripts)
558
559 srclink_files = \
560         man/footer.rst \
561         test/check-cert-expired_unittest.bash \
562         test/daemon-util_unittest.bash \
563         test/ganeti-cleaner_unittest.bash \
564         test/import-export_unittest.bash \
565         $(all_python_code)
566
567 check_python_code = \
568         $(BUILD_BASH_COMPLETION) \
569         $(all_python_code)
570
571 lint_python_code = \
572         ganeti \
573         ganeti/http/server.py \
574         $(dist_sbin_SCRIPTS) \
575         $(dist_tools_SCRIPTS) \
576         $(pkglib_python_scripts) \
577         $(BUILD_BASH_COMPLETION) \
578         $(PYTHON_BOOTSTRAP)
579
580 test/daemon-util_unittest.bash: daemons/daemon-util
581
582 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
583
584 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
585         sed -f $(REPLACE_VARS_SED) < $< > $@
586         chmod +x $@
587
588 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
589         sed -f $(REPLACE_VARS_SED) < $< > $@
590         chmod u+x $@
591
592 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
593         sed -f $(REPLACE_VARS_SED) < $< > $@
594         chmod +x $@
595
596 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
597         sed -f $(REPLACE_VARS_SED) < $< > $@
598
599 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
600         sed -f $(REPLACE_VARS_SED) < $< > $@
601
602 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
603         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
604         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
605
606 doc/%.png: doc/%.dot
607         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
608         $(DOT) -Tpng -o $@ $<
609
610 man/footer.man: man/footer.rst
611         @test -n "$(PANDOC)" || \
612           { echo 'pandoc' not found during configure; exit 1; }
613         $(PANDOC) -f rst -t man -o $@ $<
614
615 man/footer.html: man/footer.rst
616         @test -n "$(PANDOC)" || \
617           { echo 'pandoc' not found during configure; exit 1; }
618         $(PANDOC) -f rst -t html -o $@ $<
619
620 man/%.7.in man/%.8.in: man/%.rst man/footer.man
621         @test -n "$(PANDOC)" || \
622           { echo 'pandoc' not found during configure; exit 1; }
623         set -o pipefail ; \
624         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
625           sed -e 's/\\@/@/g' > $@
626         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN) $@; fi
627
628 man/%.html.in: man/%.rst man/footer.html
629         @test -n "$(PANDOC)" || \
630           { echo 'pandoc' not found during configure; exit 1; }
631         set -o pipefail ; \
632         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
633           sed -e 's/\\@/@/g' > $@
634
635 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
636         sed -f $(REPLACE_VARS_SED) < $< > $@
637
638 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
639         sed -f $(REPLACE_VARS_SED) < $< > $@
640
641 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
642         sed -f $(REPLACE_VARS_SED) < $< > $@
643
644 epydoc.conf: epydoc.conf.in
645         sed -e 's#@MODULES@#$(lint_python_code)#g' < $< > $@
646
647 vcs-version:
648         if test -d .git; then \
649           git describe > $@; \
650         elif test ! -f $@ ; then \
651           echo "Cannot auto-generate $@ file"; exit 1; \
652         fi
653
654 .PHONY: regen-vcs-version
655 regen-vcs-version:
656         set -e; \
657         cd $(srcdir); \
658         if test -d .git; then \
659           rm -f vcs-version; \
660           $(MAKE) vcs-version; \
661         fi
662
663 lib/_autoconf.py: Makefile vcs-version | lib/.dir
664         set -e; \
665         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
666         { echo '# This file is automatically generated, do not edit!'; \
667           echo '#'; \
668           echo ''; \
669           echo '"""Build-time configuration for Ganeti.'; \
670           echo '';\
671           echo 'This file is autogenerated by the build process.'; \
672           echo 'For any changes you need to re-run ./configure (and'; \
673           echo 'not edit by hand).'; \
674           echo ''; \
675           echo '"""'; \
676           echo ''; \
677           echo '# pylint: disable-msg=C0301,C0324'; \
678           echo '# because this is autogenerated, we do not want'; \
679           echo '# style warnings' ; \
680           echo ''; \
681           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
682           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
683           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
684           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
685           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
686           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
687           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
688           echo "SYSCONFDIR = '$(sysconfdir)'"; \
689           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
690           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
691           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
692           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
693           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
694           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
695           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
696           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
697           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
698           echo "KVM_PATH = '$(KVM_PATH)'"; \
699           echo "SOCAT_PATH = '$(SOCAT)'"; \
700           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
701           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
702           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
703           echo "TOOLSDIR = '$(toolsdir)'"; \
704           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
705           echo "PKGLIBDIR = '$(pkglibdir)'"; \
706           echo "DRBD_BARRIERS = $(DRBD_BARRIERS)"; \
707           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
708           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
709           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
710           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
711           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
712           echo "RAPI_USER = '$(RAPI_USER)'"; \
713           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
714           echo "CONFD_USER = '$(CONFD_USER)'"; \
715           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
716           echo "NODED_USER = '$(NODED_USER)'"; \
717           echo "VCS_VERSION = '$$VCSVER'"; \
718           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
719         } > $@
720
721 $(REPLACE_VARS_SED): Makefile
722         set -e; \
723         { echo 's#@PREFIX@#$(prefix)#g'; \
724           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
725           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
726           echo 's#@BINDIR@#$(bindir)#g'; \
727           echo 's#@SBINDIR@#$(sbindir)#g'; \
728           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
729           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
730           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
731           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
732           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
733           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
734           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
735           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
736           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
737           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
738           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
739           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
740           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
741           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
742           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
743           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
744           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
745           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
746         } > $@
747
748 # Using deferred evaluation
749 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
750 daemons/ganeti-watcher: MODULE = ganeti.watcher
751 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
752
753 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
754         test -n "$(MODULE)" || { echo Missing module; exit 1; }
755         set -e; \
756         { echo '#!/usr/bin/python'; \
757           echo '# This file is automatically generated, do not edit!'; \
758           echo "# Edit $(MODULE) instead."; \
759           echo; \
760           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
761           echo; \
762           echo '# pylint: disable-msg=C0103'; \
763           echo '# C0103: Invalid name'; \
764           echo; \
765           echo 'import sys'; \
766           echo 'import $(MODULE) as main'; \
767           echo; \
768           echo '# Temporarily alias commands until bash completion'; \
769           echo '# generator is changed'; \
770           echo 'if hasattr(main, "commands"):'; \
771                 echo '  commands = main.commands # pylint: disable-msg=E1101'; \
772           echo; \
773           echo 'if __name__ == "__main__":'; \
774           echo '  sys.exit(main.Main())'; \
775         } > $@
776         chmod u+x $@
777
778 # We need to create symlinks because "make distcheck" will not install Python
779 # files when building.
780 stamp-srclinks: Makefile | $(all_dirfiles)
781         set -e; \
782         for i in $(srclink_files); do \
783                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
784                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
785                 fi; \
786         done
787         touch $@
788
789 .PHONY: ganeti
790 ganeti:
791         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
792
793 .PHONY: check-dirs
794 check-dirs: $(BUILT_SOURCES)
795         @set -e; \
796         find . -type d \( \( -name . \) -o \( \
797                 -name .git -o \
798                 -name autom4te.cache \
799                 \) -prune -o -print \) | { \
800                 error=; \
801                 while read dir; do \
802                         case "$$dir" in \
803                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
804                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
805                         esac; \
806                 done; \
807                 for dir in $(DIRS); do \
808                         if ! test -d "$$dir"; then \
809                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
810                                 error=1; \
811                         fi \
812                 done; \
813                 if test -n "$$error"; then exit 1; else exit 0; fi; \
814         }
815
816 check-local: check-dirs
817         $(CHECK_PYTHON_CODE) $(check_python_code)
818         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
819         $(CHECK_NEWS) < $(top_srcdir)/NEWS
820
821 .PHONY: lint
822 lint: $(BUILT_SOURCES)
823         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
824         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
825         cd $(top_srcdir)/qa && \
826           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
827           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
828
829 # a dist hook rule for updating the vcs-version file; this is
830 # hardcoded due to where it needs to build the file...
831 dist-hook:
832         $(MAKE) regen-vcs-version && \
833         rm -f $(top_distdir)/vcs-version && \
834         cp -p $(srcdir)/vcs-version $(top_distdir)
835
836 # a distcheck hook rule for catching revision control directories
837 distcheck-hook:
838         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
839                 echo "Found revision control files in final archive." 1>&2; \
840                 exit 1; \
841         fi
842         if find $(top_distdir) -name '*.py[co]' | grep .; then \
843                 echo "Found Python byte code in final archive." 1>&2; \
844                 exit 1; \
845         fi
846         if find $(top_distdir) -name '*~' | grep .; then \
847                 echo "Found backup files in final archive." 1>&2; \
848                 exit 1; \
849         fi
850 # Empty files or directories should not be distributed. They can cause
851 # unnecessary warnings for packagers. Directories used by automake during
852 # distcheck must be excluded.
853         if find $(top_distdir) -empty -and -not \( \
854                         -path $(top_distdir)/_build -or \
855                         -path $(top_distdir)/_inst \) | grep .; then \
856                 echo "Found empty files or directories in final archive." 1>&2; \
857                 exit 1; \
858         fi
859         if test -n "$(BUILD_RELEASE)" && \
860            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
861                 echo "Found unreleased version in NEWS." >&2; \
862                 exit 1; \
863         fi
864
865 # When building a release, stricter checks should be used
866 distcheck-release dist-release: export BUILD_RELEASE = 1
867 distcheck-release: distcheck
868
869 dist-release: dist
870         set -e; \
871         for i in $(DIST_ARCHIVES); do \
872                 echo -n "Checking $$i ... "; \
873                 autotools/check-tar < $$i; \
874                 echo OK; \
875         done
876
877 install-exec-local:
878         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
879           "$(DESTDIR)${localstatedir}/log/ganeti" \
880           "$(DESTDIR)${localstatedir}/run/ganeti"
881
882 # To avoid conflicts between directory names and other targets, a file inside
883 # the directory is used to ensure its existence.
884 %.dir:
885         @mkdir_p@ $* && touch $@
886
887 .PHONY: apidoc
888 apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
889         $(RUN_IN_TEMPDIR) epydoc -v \
890                 --conf $(CURDIR)/epydoc.conf \
891                 --output $(CURDIR)/doc/api
892
893 .PHONY: TAGS
894 TAGS: $(BUILT_SOURCES)
895         rm -f TAGS
896         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
897           -path './daemons/ganeti-*' -o -path './tools/*' -o \
898           -path './qa/*.py' | \
899           etags -l python -
900
901 .PHONY: coverage
902 coverage: $(BUILT_SOURCES) $(python_tests)
903         set -e; \
904         COVERAGE_FILE=$(CURDIR)/doc/coverage/data \
905         TEXT_COVERAGE=$(CURDIR)/doc/coverage/report.txt \
906         HTML_COVERAGE=$(CURDIR)/doc/coverage \
907         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
908         $(python_tests)
909
910 commit-check: distcheck lint apidoc
911
912 -include ./Makefile.local
913
914 # vim: set noet :